<?php

namespace MyApp\Controller;

use MyApp\Core\Controller;
use MyApp\Model\ServersModel;
use MyApp\Service\PingService;
use MyApp\View\PingView as View;

class PingController extends Controller
{
    /**
     * @RouteRegExp = "|^/ping/history/(?<id>\d+)$|"
     * @HttpMethod = "GET"
     *
     * @param $id
     */
    public function history($id)
    {
        if ($model = (new PingService())->getTableData((int) $id)) {
            $servers = ServersModel::find([(int) $id]);
            $server_name = $servers ? $servers[0]->getName() : '';
            $this->htmlResponse((new View())->history($model, $server_name));
        } else {
            $this->redirect('/');
        }
    }

    /**
     * @RouteRegExp = "|^/ping/(?<server_id>\d+)$|"
     * @HttpMethod = "POST"
     *
     * @param $server_id
     */
    public function ping($server_id)
    {
        $out = (new PingService())->ping($server_id);
        if ($out) {
            $this->jsonResponse((object) array_merge(['status' => 'ok'], $out));
        } else {
            $this->jsonResponse((object) ['status' => 'error']);
        }
    }
}
