<?php

namespace MyApp\Service;

class DefaultService
{
    private function getGroupsArray(
        ?array $models,
        array $servers_arr,
        $parent_id = null
    ) {
        $out = [];
        if ($models) {
            foreach ($models as $item) {
                /** @var \MyApp\Model\GroupsModel $item */
                if (
                    $item->getParent() === $parent_id) {
                    $out_item = [
                        'name' => $item->getName(),
                        'type' => 'group',
                        'items' => $this->getGroupsArray($models, $servers_arr,
                            $item->getId()),
                    ];
                    if (array_key_exists($item->getId(), $servers_arr)) {
                        $out_item['items'] = array_merge($out_item['items'],
                            $servers_arr[$item->getId()]);
                    }

                    $out[] = $out_item;
                }
            }
        }

        return $out;
    }

    public function getTree()
    {
        $groups = (new GroupsService())->getTableData();
        $servers = (new ServersService())->getTableData();
        $servers_arr = [];
        if ($servers) {
            foreach ($servers as $server) {
                $servers_arr[$server->getGroup()][] = [
                    'name' => $server->getName(),
                    'type' => 'server',
                    'id' => $server->getId(),
                ];
            }
        }

        $out = [];

        $out = $this->getGroupsArray($groups, $servers_arr);
        if (array_key_exists(null, $servers_arr)) {
            $out = array_merge($out, $servers_arr[null]);
        }

        return $out;
    }
}
