<?php

namespace MyApp\Service;

use MyApp\Model\TallyLogsModel;
use MyApp\Core\Model;
use MyApp\Model\ServersModel;
use DateTime;

class PingService
{
    public function getTableData(int $server_id): ?array
    {
        $models = TallyLogsModel::find(null, null, '{server} = :server_id',
            ['server_id' => $server_id], 'id DESC');

        return $models;
    }

    public function ping($server_id): ?array
    {
        $server = ServersModel::find([$server_id], null, null, [], '', '1');

        if (!empty($server)) {
            $ip = $server[0]->getIp();
            exec("ping -c 10 $ip", $output, $status);
            foreach ($output as $line) {
                if (preg_match('/(?<transmitted>\d+)[\w\ ]*,\ (?<received>\d+)[\w\ ]*, (?<lost>\d+)%/',
                    $line, $m)) {
                    $log = (new TallyLogsModel())->setTime(new DateTime())
                                                 ->setLost((int) $m['lost'])
                                                 ->setTransmitted((int) $m['transmitted'])
                                                 ->setReceived((int) $m['received'])
                                                 ->setServer($server[0]);

                    Model::save([$log]);

                    return [
                        'name' => $server[0]->getName(),
                        'ip' => $server[0]->getIp(),
                        'lost' => $m['lost'],
                        'transmitted' => $m['transmitted'],
                        'received' => $m['received'],
                    ];
                }
            }
        }

        return null;
    }
}
